/***************************************************************************
 *   Copyright (C) 2007, IBM                                               *
 *                                                                         *
 *   Maintained By:                                                        *
 *   Eric Munson and Brad Peters                                           *
 *   munsone@us.ibm.com, bpeters@us.ibm.com                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the Lesser GNU General Public License as        *
 *   published by the Free Software Foundation; either version 2.1 of the  *
 *   License, or at your option) any later version.                        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU Lesser General Public License for more details.                   *
 *                                                                         *
 *   You should have received a copy of the Lesser GNU General Public      *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef VPDDBENV_H_
#define VPDDBENV_H_

#include <stdlib.h>
#include <string.h>
#include <db.h>

#include <libvpd-1/component.h>
#include <libvpd-1/system.h>

#define DEFAULT_ENV "/var/lib/lsvpd"
#define DEFAULT_DB  "db"

struct vpddbenv
{
	u_int32_t cFlags;
	char envDir[ 256 ];
	char dbFileName[ 256 ];
	DB *db;
	DB_ENV *env;
};

struct vpddbenv * new_vpddbenv( const char *dir, const char *file, u_int32_t flags );
void free_vpddbenv( struct vpddbenv *freeme );
struct component* fetch_component( struct vpddbenv *db, const char *deviceID );
struct system* fetch_system( struct vpddbenv *db );

int compare_keys( DB *db, const DBT *key1, const DBT *key2 );

#endif /*VPDDBENV_H_*/
